# coding: utf-8

"""
    FINBOURNE Horizon API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing import overload, Optional, Union, Awaitable

from pydantic import StrictStr

from typing import Dict, List, Optional

from finbourne_horizon.models.lusid_field import LusidField
from finbourne_horizon.models.lusid_property_definition_overrides import LusidPropertyDefinitionOverrides
from finbourne_horizon.models.lusid_property_definition_overrides_response import LusidPropertyDefinitionOverridesResponse
from finbourne_horizon.models.lusid_property_to_vendor_field_mapping import LusidPropertyToVendorFieldMapping
from finbourne_horizon.models.paged_resource_list_of_vendor_product import PagedResourceListOfVendorProduct
from finbourne_horizon.models.query_request import QueryRequest

from finbourne_horizon.api_client import ApiClient
from finbourne_horizon.api_response import ApiResponse
from finbourne_horizon.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class VendorApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @overload
    async def get_core_field_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> List[LusidField]:  # noqa: E501
        ...

    @overload
    def get_core_field_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=True, **kwargs) -> List[LusidField]:  # noqa: E501
        ...

    @validate_arguments
    def get_core_field_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=None, **kwargs) -> Union[List[LusidField], Awaitable[List[LusidField]]]:  # noqa: E501
        """[EARLY ACCESS] GetCoreFieldMappingsForProductEntity: Get core field mappings for a given vendor product's entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_core_field_mappings_for_product_entity(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[LusidField]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_core_field_mappings_for_product_entity_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.get_core_field_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, **kwargs)  # noqa: E501

    @validate_arguments
    def get_core_field_mappings_for_product_entity_with_http_info(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] GetCoreFieldMappingsForProductEntity: Get core field mappings for a given vendor product's entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_core_field_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[LusidField], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vendor_name',
            'product_name',
            'lusid_entity_type',
            'lusid_entity_sub_type'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_core_field_mappings_for_product_entity" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('vendor_name') is not None:  # noqa: E501
            _query_params.append(('vendorName', _params['vendor_name']))

        if _params.get('product_name') is not None:  # noqa: E501
            _query_params.append(('productName', _params['product_name']))

        if _params.get('lusid_entity_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntityType', _params['lusid_entity_type']))

        if _params.get('lusid_entity_sub_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntitySubType', _params['lusid_entity_sub_type']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "List[LusidField]",
        }

        return self.api_client.call_api(
            '/api/vendor/mappings/fields', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def get_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> Dict[str, LusidPropertyDefinitionOverrides]:  # noqa: E501
        ...

    @overload
    def get_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=True, **kwargs) -> Dict[str, LusidPropertyDefinitionOverrides]:  # noqa: E501
        ...

    @validate_arguments
    def get_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=None, **kwargs) -> Union[Dict[str, LusidPropertyDefinitionOverrides], Awaitable[Dict[str, LusidPropertyDefinitionOverrides]]]:  # noqa: E501
        """[EARLY ACCESS] GetOptionalMappingsForProductEntity: Get a user defined LUSID property mappings for the specified vendor / LUSID entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_optional_mappings_for_product_entity(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Dict[str, LusidPropertyDefinitionOverrides]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_optional_mappings_for_product_entity_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.get_optional_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, **kwargs)  # noqa: E501

    @validate_arguments
    def get_optional_mappings_for_product_entity_with_http_info(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] GetOptionalMappingsForProductEntity: Get a user defined LUSID property mappings for the specified vendor / LUSID entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_optional_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Dict[str, LusidPropertyDefinitionOverrides], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vendor_name',
            'product_name',
            'lusid_entity_type',
            'lusid_entity_sub_type'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_optional_mappings_for_product_entity" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('vendor_name') is not None:  # noqa: E501
            _query_params.append(('vendorName', _params['vendor_name']))

        if _params.get('product_name') is not None:  # noqa: E501
            _query_params.append(('productName', _params['product_name']))

        if _params.get('lusid_entity_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntityType', _params['lusid_entity_type']))

        if _params.get('lusid_entity_sub_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntitySubType', _params['lusid_entity_sub_type']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "Dict[str, LusidPropertyDefinitionOverrides]",
        }

        return self.api_client.call_api(
            '/api/vendor/mappings/optional', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def get_property_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> List[LusidPropertyToVendorFieldMapping]:  # noqa: E501
        ...

    @overload
    def get_property_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=True, **kwargs) -> List[LusidPropertyToVendorFieldMapping]:  # noqa: E501
        ...

    @validate_arguments
    def get_property_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=None, **kwargs) -> Union[List[LusidPropertyToVendorFieldMapping], Awaitable[List[LusidPropertyToVendorFieldMapping]]]:  # noqa: E501
        """[EARLY ACCESS] GetPropertyMappingsForProductEntity: Gets the property mappings for a given vendor product's entity  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_property_mappings_for_product_entity(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: List[LusidPropertyToVendorFieldMapping]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the get_property_mappings_for_product_entity_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.get_property_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, **kwargs)  # noqa: E501

    @validate_arguments
    def get_property_mappings_for_product_entity_with_http_info(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] GetPropertyMappingsForProductEntity: Gets the property mappings for a given vendor product's entity  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_property_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(List[LusidPropertyToVendorFieldMapping], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vendor_name',
            'product_name',
            'lusid_entity_type',
            'lusid_entity_sub_type'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_property_mappings_for_product_entity" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('vendor_name') is not None:  # noqa: E501
            _query_params.append(('vendorName', _params['vendor_name']))

        if _params.get('product_name') is not None:  # noqa: E501
            _query_params.append(('productName', _params['product_name']))

        if _params.get('lusid_entity_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntityType', _params['lusid_entity_type']))

        if _params.get('lusid_entity_sub_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntitySubType', _params['lusid_entity_sub_type']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "List[LusidPropertyToVendorFieldMapping]",
        }

        return self.api_client.call_api(
            '/api/vendor/mappings/properties', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def query_vendors(self, query_request : QueryRequest, **kwargs) -> PagedResourceListOfVendorProduct:  # noqa: E501
        ...

    @overload
    def query_vendors(self, query_request : QueryRequest, async_req: Optional[bool]=True, **kwargs) -> PagedResourceListOfVendorProduct:  # noqa: E501
        ...

    @validate_arguments
    def query_vendors(self, query_request : QueryRequest, async_req: Optional[bool]=None, **kwargs) -> Union[PagedResourceListOfVendorProduct, Awaitable[PagedResourceListOfVendorProduct]]:  # noqa: E501
        """[EARLY ACCESS] QueryVendors: Query for vendors and their packages with entities and sub-entities.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.query_vendors(query_request, async_req=True)
        >>> result = thread.get()

        :param query_request:  (required)
        :type query_request: QueryRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: PagedResourceListOfVendorProduct
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the query_vendors_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.query_vendors_with_http_info(query_request, **kwargs)  # noqa: E501

    @validate_arguments
    def query_vendors_with_http_info(self, query_request : QueryRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] QueryVendors: Query for vendors and their packages with entities and sub-entities.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.query_vendors_with_http_info(query_request, async_req=True)
        >>> result = thread.get()

        :param query_request:  (required)
        :type query_request: QueryRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(PagedResourceListOfVendorProduct, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'query_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method query_vendors" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['query_request'] is not None:
            _body_params = _params['query_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "PagedResourceListOfVendorProduct",
        }

        return self.api_client.call_api(
            '/api/vendor/$query', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @overload
    async def set_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, request_body : Dict[str, LusidPropertyDefinitionOverrides], lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> Dict[str, LusidPropertyDefinitionOverridesResponse]:  # noqa: E501
        ...

    @overload
    def set_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, request_body : Dict[str, LusidPropertyDefinitionOverrides], lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=True, **kwargs) -> Dict[str, LusidPropertyDefinitionOverridesResponse]:  # noqa: E501
        ...

    @validate_arguments
    def set_optional_mappings_for_product_entity(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, request_body : Dict[str, LusidPropertyDefinitionOverrides], lusid_entity_sub_type : Optional[StrictStr] = None, async_req: Optional[bool]=None, **kwargs) -> Union[Dict[str, LusidPropertyDefinitionOverridesResponse], Awaitable[Dict[str, LusidPropertyDefinitionOverridesResponse]]]:  # noqa: E501
        """[EARLY ACCESS] SetOptionalMappingsForProductEntity: Create a user defined LUSID property mappings for the specified vendor / LUSID entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.set_optional_mappings_for_product_entity(vendor_name, product_name, lusid_entity_type, request_body, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param request_body:  (required)
        :type request_body: Dict[str, LusidPropertyDefinitionOverrides]
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request.
               If one number provided, it will be total request
               timeout. It can also be a pair (tuple) of
               (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: Dict[str, LusidPropertyDefinitionOverridesResponse]
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            message = "Error! Please call the set_optional_mappings_for_product_entity_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data"  # noqa: E501
            raise ValueError(message)
        if async_req is not None:
            kwargs['async_req'] = async_req
        return self.set_optional_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, request_body, lusid_entity_sub_type, **kwargs)  # noqa: E501

    @validate_arguments
    def set_optional_mappings_for_product_entity_with_http_info(self, vendor_name : StrictStr, product_name : StrictStr, lusid_entity_type : StrictStr, request_body : Dict[str, LusidPropertyDefinitionOverrides], lusid_entity_sub_type : Optional[StrictStr] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """[EARLY ACCESS] SetOptionalMappingsForProductEntity: Create a user defined LUSID property mappings for the specified vendor / LUSID entity.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.set_optional_mappings_for_product_entity_with_http_info(vendor_name, product_name, lusid_entity_type, request_body, lusid_entity_sub_type, async_req=True)
        >>> result = thread.get()

        :param vendor_name:  (required)
        :type vendor_name: str
        :param product_name:  (required)
        :type product_name: str
        :param lusid_entity_type:  (required)
        :type lusid_entity_type: str
        :param request_body:  (required)
        :type request_body: Dict[str, LusidPropertyDefinitionOverrides]
        :param lusid_entity_sub_type: 
        :type lusid_entity_sub_type: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(Dict[str, LusidPropertyDefinitionOverridesResponse], status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vendor_name',
            'product_name',
            'lusid_entity_type',
            'request_body',
            'lusid_entity_sub_type'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method set_optional_mappings_for_product_entity" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('vendor_name') is not None:  # noqa: E501
            _query_params.append(('vendorName', _params['vendor_name']))

        if _params.get('product_name') is not None:  # noqa: E501
            _query_params.append(('productName', _params['product_name']))

        if _params.get('lusid_entity_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntityType', _params['lusid_entity_type']))

        if _params.get('lusid_entity_sub_type') is not None:  # noqa: E501
            _query_params.append(('lusidEntitySubType', _params['lusid_entity_sub_type']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['request_body'] is not None:
            _body_params = _params['request_body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['oauth2']  # noqa: E501

        _response_types_map = {
            '200': "Dict[str, LusidPropertyDefinitionOverridesResponse]",
        }

        return self.api_client.call_api(
            '/api/vendor/mappings/optional', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
