# coding: utf-8

"""
    FINBOURNE Horizon API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictStr, constr

class LusidEntity(BaseModel):
    """
    Information about the LUSID entity this data can be used with  # noqa: E501
    """
    entity_type: constr(strict=True, min_length=1) = Field(..., alias="entityType", description="The entity type")
    entity_type_display_name: constr(strict=True, min_length=1) = Field(..., alias="entityTypeDisplayName", description="The display name for the entity type.")
    entity_sub_type: Optional[StrictStr] = Field(None, alias="entitySubType", description="The entity sub-type")
    entity_sub_type_display_name: Optional[StrictStr] = Field(None, alias="entitySubTypeDisplayName", description="Display name for the entity sub-type")
    __properties = ["entityType", "entityTypeDisplayName", "entitySubType", "entitySubTypeDisplayName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> LusidEntity:
        """Create an instance of LusidEntity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # set to None if entity_sub_type (nullable) is None
        # and __fields_set__ contains the field
        if self.entity_sub_type is None and "entity_sub_type" in self.__fields_set__:
            _dict['entitySubType'] = None

        # set to None if entity_sub_type_display_name (nullable) is None
        # and __fields_set__ contains the field
        if self.entity_sub_type_display_name is None and "entity_sub_type_display_name" in self.__fields_set__:
            _dict['entitySubTypeDisplayName'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> LusidEntity:
        """Create an instance of LusidEntity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return LusidEntity.parse_obj(obj)

        _obj = LusidEntity.parse_obj({
            "entity_type": obj.get("entityType"),
            "entity_type_display_name": obj.get("entityTypeDisplayName"),
            "entity_sub_type": obj.get("entitySubType"),
            "entity_sub_type_display_name": obj.get("entitySubTypeDisplayName")
        })
        return _obj
