# coding: utf-8

"""
    FINBOURNE Horizon API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from finbourne_horizon.models.open_figi_perm_id_result import OpenFigiPermIdResult

class OnboardInstrumentRequest(BaseModel):
    """
    The full structure of a instrument creation / onboarding request  # noqa: E501
    """
    data_results: conlist(OpenFigiPermIdResult) = Field(..., alias="dataResults", description="Enumerable packed OpenFigi/PermId information used to create instruments")
    primary_vendor_key: Optional[StrictStr] = Field(None, alias="primaryVendorKey", description="Primary vendor used to master instrument from Unknown to an asset type")
    secondary_vendor_keys: Optional[conlist(StrictStr)] = Field(None, alias="secondaryVendorKeys", description="Secondary vendors used to decorate additional properties")
    __properties = ["dataResults", "primaryVendorKey", "secondaryVendorKeys"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> OnboardInstrumentRequest:
        """Create an instance of OnboardInstrumentRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in data_results (list)
        _items = []
        if self.data_results:
            for _item in self.data_results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['dataResults'] = _items
        # set to None if primary_vendor_key (nullable) is None
        # and __fields_set__ contains the field
        if self.primary_vendor_key is None and "primary_vendor_key" in self.__fields_set__:
            _dict['primaryVendorKey'] = None

        # set to None if secondary_vendor_keys (nullable) is None
        # and __fields_set__ contains the field
        if self.secondary_vendor_keys is None and "secondary_vendor_keys" in self.__fields_set__:
            _dict['secondaryVendorKeys'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> OnboardInstrumentRequest:
        """Create an instance of OnboardInstrumentRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return OnboardInstrumentRequest.parse_obj(obj)

        _obj = OnboardInstrumentRequest.parse_obj({
            "data_results": [OpenFigiPermIdResult.from_dict(_item) for _item in obj.get("dataResults")] if obj.get("dataResults") is not None else None,
            "primary_vendor_key": obj.get("primaryVendorKey"),
            "secondary_vendor_keys": obj.get("secondaryVendorKeys")
        })
        return _obj
